$(document).ready(function(){
  persistence.store.websql.config(persistence, 'persistencetest', 'My db', 5 * 1024 * 1024);
  //persistence.store.memory.config(persistence);
  persistence.debug = true;

  var Project = persistence.define('Project', {
      name: "TEXT"
    });

  var Task = persistence.define('Task', {
      name: "TEXT",
      done: "BOOL",
      counter: "INT",
      dateAdded: "DATE",
      metaData: "JSON"
    });

  var Tag = persistence.define('Tag', {
      name: "TEXT"
    });

  Task.hasMany('tags', Tag, 'tasks');
  Tag.hasMany('tasks', Task, 'tags');

  Project.hasMany('tasks', Task, 'project');

  window.Project = Project;
  window.Task = Task
  window.Project = Project;

  persistence.reset(function() {
      persistence.schemaSync(function() {
          var project = new Project({name: "My project"});
          persistence.add(project);
          var tags = [];
          for(var i = 0; i < 5; i++) {
            var tag = new Tag({name: "Tag " + i});
            persistence.add(tag);
            tags.push(tag);
          }
          for(var i = 0; i < 10; i++) {
            var task = new Task({name: "Task " + i});
            task.tags = new persistence.LocalQueryCollection(tags);
            project.tasks.add(task);
          }
          project.selectJSON(['id', 'name', 'tasks.[id,name]', 'tasks.tags.[id, name]'], function(result) {
              console.log(JSON.stringify(result));
              persistence.reset(function() {
                  persistence.schemaSync(function() {
                      Project.fromSelectJSON(result, function(obj) {
                          persistence.add(obj);
                          Task.all().list(function(tasks) {
                              console.log("----------------------------------");
                              tasks.forEach(function(task) {
                                  task.done = true;
                                });
                              Project.fromSelectJSON(result, function(obj) {
                                  persistence.flush();
                                });
                            });
                        });
                    });
                });
            });
        });
    });

});
